# Запуск бенчмарков

## CLI

```bash
benchos run [FILE]
```

`FILE` - имя файла класса бенчмарков в текущем каталоге, либо полный путь к нему

**Примеры использования:**

```bash
# Запуск по имени класса (файл МойКласс.os должен существовать в текущей директории)
benchos run МойКласс

# Запуск по имени файла в текущей директории
benchos run МойКласс.os

# Запуск по абсолютному пути
benchos run /path/to/МойКласс.os
```

## API

### Базовый сценарий

```bsl
// Запуск по типу класса бенчмарков
Результат = Бенчмаркинг.Запустить(Тип("МойКласс"));

// Запуск через экземпляр класса бенчмарков
Результат = Бенчмаркинг.Запустить(Новый МойКласс);
```

### Запуск отдельных бенчмарков

```bsl
ДескрипторыБенчмарков = Новый КоллекцияДескрипторовБенчмарков(Тип("МойКласс"));

// Запуск конкретного бенчмарка
ДескрипторБенчмарка = ДескрипторыБенчмарков.НайтиПоИмени("МойБенчмарк");
Результат = Бенчмаркинг.Запустить(ДескрипторБенчмарка);

// Запуск отфильтрованного списка
ДескрипторыБенчмарков.Фильтровать("Элемент -> Элемент.Категория() = ""МояКатегория""");
Результат = Бенчмаркинг.Запустить(ДескрипторыБенчмарков);
```

### Передача конфигурации

```bsl
// Создание новой конфигурации
Конфигурация = Новый КонфигурацияБенчмарков();
Конфигурация.УстановитьКоличествоИтераций(10);
Результат = Бенчмаркинг.Запустить(Тип("МойКласс"), Конфигурация);

// Модификация существующей конфигурации
Конфигурация = Новый КонфигурацияБенчмарков(Тип("МойКласс"));
Конфигурация.УстановитьКоличествоИтераций(10);
Результат = Бенчмаркинг.Запустить(Тип("МойКласс"), Конфигурация);
```
