# Мониторинг памяти

Для анализа аллокаций предусмотрена аннотация `&МониторингПамяти`.

### Аннотация

```bsl
&МониторингПамяти
Процедура ПриСозданииОбъекта()
```

### API

```bsl
Конфигурация.ДобавитьМониторингПамяти();
```

### Пример

```bsl
&МониторингПамяти
Процедура ПриСозданииОбъекта()
КонецПроцедуры

&Бенчмарк
&Параметры(100)
&Параметры(1000)
Процедура Бенчмарк(Количество) Экспорт
	Строка = "";
	Для к = 1 По Количество Цикл
		Строка = Строка + "Просто текст";
	КонецЦикла;
КонецПроцедуры
```

### Вывод

| Method   | Количество |        Mean |      StdErr |    StdDev |      Median |     Op/s |   Allocated |
|----------|-----------:|------------:|------------:|----------:|------------:|---------:|------------:|
| Бенчмарк |        100 |    44.01 us |    504.0 ns |  1.952 us |    43.72 us | 22,723.2 |    126.9 KB |
| Бенчмарк |      1,000 | 1,293.41 us | 21,401.2 ns | 82.887 us | 1,260.40 us |    773.1 | 11,809.4 KB |
