# Сортировка отчета

### Аннотации

```bsl
// Сортировка результатов по убыванию производительности (от лучшего к худшему)
&СортировкаОтБыстрыхКМедленным
Процедура ПриСозданииОбъекта()

// Сортировка результатов по возрастанию времени выполнения (от худшего к лучшему)
&СортировкаОтМедленныхКБыстрым
Процедура ПриСозданииОбъекта()

// Сортировка результатов по наименованию метода бенчмарка
&СортировкаПоМетоду
Процедура ПриСозданииОбъекта()
```

### API

```bsl
Конфигурация.УстановитьСортировкуОтчета(СортировкиОтчетаБенчмарков.ПоУмолчанию);
Конфигурация.УстановитьСортировкуОтчета(СортировкиОтчетаБенчмарков.ОтБыстрыхКМедленным);
Конфигурация.УстановитьСортировкуОтчета(СортировкиОтчетаБенчмарков.ОтМедленныхКБыстрым);
Конфигурация.УстановитьСортировкуОтчета(СортировкиОтчетаБенчмарков.ПоМетоду);
```

### Пример

```bsl
&Параметры(1, 2, 3)
Перем Множитель Экспорт;

&СортировкаОтБыстрыхКМедленным
Процедура ПриСозданииОбъекта()
КонецПроцедуры

&Бенчмарк
Процедура Медленный() Экспорт
	Приостановить(Множитель * 20);
КонецПроцедуры

&Бенчмарк
Процедура Быстрый() Экспорт
	Приостановить(Множитель * 10);
КонецПроцедуры
```

### Вывод

| Method    | Множитель |     Mean |    StdErr |    StdDev |   Median |  Op/s |
|-----------|----------:|---------:|----------:|----------:|---------:|------:|
| Быстрый   |         1 | 10.97 ms |  8.441 us |  32.69 us | 10.98 ms | 91.17 |
| Быстрый   |         2 | 20.93 ms | 16.253 us |  62.95 us | 20.92 ms | 47.77 |
| Медленный |         1 | 20.95 ms | 12.332 us |  47.76 us | 20.98 ms | 47.73 |
| Быстрый   |         3 | 30.92 ms | 22.293 us |  86.34 us | 30.94 ms | 32.34 |
| Медленный |         2 | 40.91 ms | 29.619 us | 114.71 us | 40.98 ms | 24.44 |
| Медленный |         3 | 60.89 ms | 29.009 us | 112.35 us | 60.93 ms | 16.42 |

