# Статистика

Для детального анализа производительности предусмотрено добавление специализированных статистических показателей.

## Min и Max

#### Аннотации

```bsl
&КолонкаМин
&КолонкаМакс
Процедура ПриСозданииОбъекта()
```

#### API

```bsl
Конфигурация.ДобавитьКолонку(КолонкиОтчетаБенчмарков.Мин);
Конфигурация.ДобавитьКолонку(КолонкиОтчетаБенчмарков.Макс);
```

### Пример вывода

| Method   |     Mean |   StdErr |   StdDev |      Min |   Median |     Max |  Op/s |
|----------|---------:|---------:|---------:|---------:|---------:|--------:|------:|
| Бенчмарк | 208.6 ms | 88.62 ms | 198.2 ms | 10.19 ms | 10.48 ms | 1.001 s | 4.794 |

## Квартили

#### Аннотации

```bsl
&КолонкаНижнийКвартиль
&КолонкаВерхнийКвартиль
Процедура ПриСозданииОбъекта()
```

#### API

```bsl
Конфигурация.ДобавитьКолонку(КолонкиОтчетаБенчмарков.НижнийКвартиль);
Конфигурация.ДобавитьКолонку(КолонкиОтчетаБенчмарков.ВерхнийКвартиль);
```

### Пример вывода

| Method   |     Mean |   StdErr |   StdDev |       Q1 |   Median |       Q3 |  Op/s |
|----------|---------:|---------:|---------:|---------:|---------:|---------:|------:|
| Бенчмарк | 26.55 ms | 1.849 ms | 7.160 ms | 7.625 us | 18.34 ms | 58.42 ms | 37.67 |

## Процентили

#### Аннотации

```bsl
// Процентили по умолчанию
&КолонкаПроцентиль
Процедура ПриСозданииОбъекта()

// Пользовательские процентили
&КолонкаПроцентиль(10, 40, 60, 80)
Процедура ПриСозданииОбъекта()
```

#### API

```bsl
Конфигурация.ДобавитьКолонку(КолонкиОтчетаБенчмарков.Процентиль); // Процентили по умолчанию
Конфигурация.ДобавитьКолонку(КолонкиОтчетаБенчмарков.Процентиль(10)); // 10-й процентиль
Конфигурация.ДобавитьКолонку(КолонкиОтчетаБенчмарков.Процентиль(40)); // 40-й процентиль
```

### Пример вывода

| Method   |     Mean |   StdErr |   StdDev |   Median |       P0 |      P50 |      P80 |      P85 |      P95 |     P100 |  Op/s |
|----------|---------:|---------:|---------:|---------:|---------:|---------:|---------:|---------:|---------:|---------:|------:|
| Бенчмарк | 27.07 ms | 356.8 us | 1.382 ms | 28.69 ms | 15.30 ms | 28.69 ms | 30.03 ms | 30.49 ms | 33.69 ms | 33.70 ms | 36.94 |
