// Указывает, что метод должен быть измерен как бенчмарк в рамках тестирования производительности.
//
// Методы с этой аннотацией автоматически включаются в процесс бенчмаркинга. 
// При запуске будут замеряться время выполнения, аллокации памяти (если включен мониторинг памяти), 
// и другие параметры производительности.
//
// Пример:
//   &Бенчмарк
//   Процедура МойБенчмарк() Экспорт
//      // Тестируемый код
//   КонецПроцедуры
&Аннотация("Бенчмарк")
Процедура ПриСозданииОбъекта()
КонецПроцедуры