// Добавляет в отчет колонку с cтандартным отклонением соотношений времени выполнения относительно эталона.
// Метрика помогает выявить аномалии в измерениях, когда отдельные выбросы искажают общую картину.
//
// Интерпретация:
//   - Низкое значение: время выполнения тестов стабильно, вариативность мала.
//   - Высокое значение: время выполнения тестов сильно меняются между запусками, что может указывать 
//     на нестабильность измерений.
//
// - Применяется только к методу ПриСозданииОбъекта.
// - Добавляется автоматически при наличии значимых данных
//
// Пример:
//   &КолонкаRatioSD
//   Процедура ПриСозданииОбъекта()
//      // ...
//   КонецПроцедуры
&Аннотация("КолонкаRatioSD")
Процедура ПриСозданииОбъекта()
КонецПроцедуры