// Задает минимальное время выполнения одной итерации бенчмарка в миллисекундах.
//
// BenchmarkOneScript динамически подбирает количество вызовов за итерацию (см. АннотацияКоличествоВызововЗаИтерацию) так, 
// чтобы одна итерация длилась не меньше указанного времени. 
// Увеличивает стабильность замеров для коротких операций.
//
// - Применяется только к методу ПриСозданииОбъекта
// - Игнорируется для стратегии "ХолодныйЗапуск"
//
// Пример:
//   &МинимальноеВремяИтерации(1000)
//   Процедура ПриСозданииОбъекта()
//      // ...
//   КонецПроцедуры
&Аннотация("МинимальноеВремяИтерации")
Процедура ПриСозданииОбъекта()
КонецПроцедуры